local vars = {}
vars.vol_master = tonumber(gkini.ReadString("SAS", "master_volume", '1.0'))
vars.NUM_SOUNDS_MAX = 12

--TODO: Choco function for int2bool
local function int2bool(int)
	if type(int) == 'number' then
		return int==1 and true or false
	elseif type(int) == 'string' then
		return tonumber(int)==1 and true or false
	else return nil end
end

vars.saved_keys = {enable='boolean',sound='number',data='string',option_enable='boolean',vol='number'} --settings to save to config
vars.defaults = {enable=true,sound='1',data='',option_enable=nil,vol=vars.vol_master} --default values to use for config keys
vars.conv_keys = {boolean=int2bool,number=tonumber,string=tostring} --function to use to convert config data

vars.sound_name = {}
local sounds = {}
for i=1,vars.NUM_SOUNDS_MAX do
	vars.sound_name[i] = "sound"..i..".ogg"
	--vars.sound_name[-1] = "sound"..i..".wav" --TODO
	
	sounds[i] = gksound.GKLoadSound{soundname=vars.sound_name[i],filename="plugins/SoundAlertSuite/sounds/"..vars.sound_name[i]}
end

vars.alerts = {
	{events={"CHAT_MSG_CHANNEL","CHAT_MSG_CHANNEL_EMOTE"},title='Chat to non-active channel',data="4357",func='isChatAlert',sound=1},
	{events={"CHAT_MSG_CHANNEL_ACTIVE","CHAT_MSG_CHANNEL_EMOTE_ACTIVE"},title='Chat to active channel',enable=false,data="4357",func='isChatAlert',sound=1},
	{events={"CHAT_MSG_PRIVATE"},title='Receive private message',func=nil,sound=2},
	{events={"CHAT_MSG_SERVER"},title='Buddy entered the game',func='isBuddyEntered',sound=3},
	{events={"CHAT_MSG_SERVER"},title='Buddy left the game',func='isBuddyLeft',sound=4},
	{events={"CHAT_MSG_SERVER"},title='Received buddy request',func='isBuddyRequest',sound=5},
	{events={"CHAT_MSG_INCOMINGBUDDYNOTE"},title='Received buddy note',func=nil,sound=6},
	{events={"CHAT_MSG_SECTORD"},title='Received credits from player',enable=false,func='isReceivedCredits',sound=7},
	--{events={"OUT_OF_AMMO"},title='Out of ammo',func=nil,sound=8}, --TODO
	{events={"ENTER_ZONE_NFZ"},title='Enter NFZ',enable=false,func=nil,sound=8},
	{events={"LEAVE_ZONE_NFZ"},title='Leave NFZ',enable=false,func=nil,sound=9},
	{events={"MISSION_NOTIFICATION"},title='Mission updated',func=nil,sound=10},
	{events={"PLAYER_DIED"},title='Scored a kill',option_title="NPC kills",option_enable=true,data=nil,enable=false,func='isScoredKill',sound=11},
}

--read saved settings from config file
for key,data_type in pairs(vars.saved_keys) do
	local data = unspickle(gkini.ReadString("SAS", key, string.rep("\"\",", #vars.alerts))) --read data into table, default is empty string
	
	--extract entry from data table and convert format
	for id,alert in ipairs(vars.alerts) do
		if data[id]=='' then alert[key] = alert[key]==nil and vars.defaults[key] or alert[key] else alert[key] = vars.conv_keys[data_type](data[id]) end
	end
end

--disable option checkbox for disabled alerts
--for _,alert in ipairs(vars.alerts) do
--	if alert.option_enable then alert.option_enable = alert.enable and "ON" or "OFF" end
--end

--Write all vars data to the config file
function vars.WriteConfig()
	for key,data_type in pairs(vars.saved_keys) do
		local data = {} --table to write
		
		for id,alert in ipairs(vars.alerts) do
			data[id] = data_type=='boolean' and (alert[key] and 1 or 0) or alert[key] or ''
		end
		
		gkini.WriteString("SAS", key, spickle(data))
	end
end

return vars